<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8" />
  <link rel="icon" href="%PUBLIC_URL%/favicon.ico" />
  <meta name="viewport" content="width=device-width, initial-scale=1" />
  <meta name="theme-color" content="#000000" />
  <meta name="description" content="Web site created using create-react-app" />
  <link rel="apple-touch-icon" href="%PUBLIC_URL%/logo192.png" />
  <script src="https://cdnjs.cloudflare.com/ajax/libs/blueimp-md5/2.5.0/js/md5.min.js"></script>

  <!--
      manifest.json provides metadata used when your web app is installed on a
      user's mobile device or desktop. See https://developers.google.com/web/fundamentals/web-app-manifest/
    -->
  <link rel="manifest" href="%PUBLIC_URL%/manifest.json" />

  <script>
        class MyEventEmitter {
    constructor() {
      this._events = {};
    }
  
    on(name, listener) {
      if (!this._events[name]) {
        this._events[name] = [];
      }
  
      this._events[name].push(listener);
    }
  
    removeListener(name, listenerToRemove) {
      if (!this._events[name]) {
        return
      }
  
      const filterListeners = (listener) => listener !== listenerToRemove;
  
      this._events[name] = this._events[name].filter(filterListeners);
    }

  
        emit(name, data) {
          if (!this._events[name]) {
            return
          }

          const fireCallbacks = (callback) => {
            callback(data);
          };

          this._events[name].forEach(fireCallbacks);
        }
      }
      
      let ArgTypes = ['text', 'address', 'data', 'fixedPoint', 'bool']
        var walletInstalled = false;
        var walletInfo = undefined;
        this.events = new MyEventEmitter();
        var methodName = 'set_value';
        var networkType = 'testnet'
        var stampLimit = 1000;
        var argName, argType, argValue
        var approveNetwork = 'testnet'
        var approveContract = 'DispeerseTau'
        this.callbacks = {};
        this.callbackError = {};
        var kwargs = {
          key_name: { type: 'text', value: '' },
          key_value: { type: 'text', value: new Date().toLocaleTimeString() }
        }

        if (document) {
          document.addEventListener('lamdenWalletInfo', (event) => {
            walletInstalled = true;
            let event2 = new Event("customInfo", { walletInstalled: true }); // (2)
            document.dispatchEvent(event2);
            console.log(event)
            if (event.detail.errors) {
              errors = event.detail.errors;
              console.log(event.detail.errors)
            }
            else {
              console.log(event.detail)
              errors = [];
              lamdenInfo = { ...event.detail };
              walletInfo = event.detail;
              let event3 = new Event("customInfo", { ...lamdenInfo, walletInstalled: true }); // (2)
              if (lamdenInfo.wallets.length > 0) {
                kwargs['key_name'].value = lamdenInfo.wallets[0] + ':time'
                kwargs = { ...kwargs }
              }
              document.dispatchEvent(event3);
            }
          });

          document.addEventListener('lamdenWalletTxStatus', (e) => {
            let txResult = e.detail.data
            debugger
            if (txResult.errors){
                if (txResult.errors.length > 0) {
                    let data = JSON.parse(txResult.rejected)
                    if (this.callbackError) this.callbackError(e.detail)
                }
            }else{
                if (Object.keys(txResult.txBlockResult).length > 0){
                    if (this.callbacks[txResult.uid]) this.callbacks[txResult.uid](e.detail)
                }
            }
            this.events.emit('txStatus', e.detail)
        })
        
          checkForWallet()
        }

        function checkForWallet() {
          document.dispatchEvent(new CustomEvent('lamdenWalletGetInfo'));
          setTimeout(() => {
            if (!walletInstalled) checkForWallet()
          }, 1000)
        }
        function connectToWallet(detail) {
          document.dispatchEvent(new CustomEvent('lamdenWalletConnect', { detail: JSON.stringify(detail) }));
        }

        function sendTx2(tx, callback, callbackError) {
          errors = [];
          tx.uid = new Date().toISOString()
          if (typeof callbackError === 'function') this.callbackError = callbackError
          if (typeof callback === 'function') this.callbacks[tx.uid] = callback
          document.dispatchEvent(new CustomEvent('lamdenWalletSendTx', { detail :JSON.stringify(tx)}));
        }

        function makeArgs() {
          let kwargsObj = {}
          Object.keys(kwargs).forEach(kwarg => {
            kwargsObj[kwarg] = kwargs[kwarg].value
          })
          return kwargsObj
        }
        function getStatus() {
          errors = [];
          document.dispatchEvent(new CustomEvent('lamdenWalletGetInfo'));
        }
        function addArg() {
          if (argName === '') return;
          if (typeof argValue === 'undefined') return
          kwargs[argName] = {
            value: selectedArgType === 'fixedPoint' ? parseFloat(argValue) : argValue,
            type: selectedArgType
          }
          kwargs = { ...kwargs }
          argName = argValue = '';
        }
        function delArg(name) {
          delete kwargs[name]
          kwargs = { ...kwargs }
        }
        function checkSelectedVk() {
          console.log(selectedVk)
        }
        function setValidation(node, message) {
          node.setCustomValidity(message);
          node.reportValidity();
        }
        function refreshValidity() {
          setValidation(argNameInput, '')
        }
        function isUndefiend(value) {
          return typeof value === 'undefined';
        }
        const toggleNewKeypair = () => reapprove ? newKeypair = false : null
        const openLink = (url) => {
      window.open(url, '_blank');
    }
  </script>
  <!--
      Notice the use of %PUBLIC_URL% in the tags above.
      It will be replaced with the URL of the `public` folder during the build.
      Only files inside the `public` folder can be referenced from the HTML.

      Unlike "/favicon.ico" or "favicon.ico", "%PUBLIC_URL%/favicon.ico" will
      work correctly both with client-side routing and a non-root public URL.
      Learn how to configure a non-root public URL by running `npm run build`.
    -->
  <title>React App</title>
</head>

<body>
  <noscript>You need to enable JavaScript to run this app.</noscript>
  <div id="root"></div>
  <!--
      This HTML file is a template.
      If you open it directly in the browser, you will see an empty page.

      You can add webfonts, meta tags, or analytics to this file.
      The build step will place the bundled scripts into the <body> tag.

      To begin the development, run `npm start` or `yarn start`.
      To create a production bundle, use `npm run build` or `yarn build`.
    -->
</body>

</html>